--Daniel Kluss(xerox_irs@lvcm.com) Registered Euphoria User Since December 2000

global constant replies={
{110,"110 Restart marker reply.\r\n"},
{120,"120 Service ready in nnn minutes.\r\n"},
{125,"125 Data connection already open; transfer starting.\r\n"},
{150,"150 File status okay; about to open data connection.\r\n"},
{200,"200 Command okay.\r\n"},
{202,"202 Command not implemented, superfluous at this site.\r\n"},
{211,"211 System status, or system help reply.\r\n"},
{212,"212 Directory status.\r\n"},
{213,"213 File status.\r\n"},
{214,"214 Help message.\r\n"},
{215,"215 NAME system type.\r\n"},
{220,"220 Service ready for new user.\r\n"},
{221,"221 Service closing control connection.\r\n"},
{225,"225 Data connection open; no transfer in progress.\r\n"},
{226,"226 Closing data connection.\r\n"},
{227,"227 Entering Passive Mode (h1,h2,h3,h4,p1,p2).\r\n"},
{230,"230 User logged in, proceed.\r\n"},
{250,"250 Requested file action okay, completed.\r\n"},
{257,"257 PATHNAME created.\r\n"},
{331,"331 User name okay, need password.\r\n"},
{332,"332 Need account for login.\r\n"},
{350,"350 Requested file action pending further information.\r\n"},
{421,"421 Service not available, closing control connection.\r\n"},
{425,"425 Can't open data connection.\r\n"},
{426,"426 Connection closed; transfer aborted.\r\n"},
{450,"450 Requested file action not taken.\r\n"},
{451,"451 Requested action aborted: local error in processing.\r\n"},
{452,"452 Requested action not taken.\r\n"},
{500,"500 Syntax error, command unrecognized.\r\n"},
{501,"501 Syntax error in parameters or arguments.\r\n"},
{502,"502 Command not implemented.\r\n"},
{503,"503 Bad sequence of commands.\r\n"},
{504,"504 Command not implemented for that parameter.\r\n"},
{530,"530 Not logged in.\r\n"},
{532,"532 Need account for storing files.\r\n"},
{550,"550 Requested action not taken.\r\n"},
{551,"551 Requested action aborted: page type unknown.\r\n"},
{552,"552 Requested file action aborted.\r\n"},
{553,"553 Requested action not taken.\r\n"}
},

error_messages={
{"ACCEPT","",{120,220,220,421}},
{"USER","<SP><username><CRLF>",{230,530,500,501,421,331,332}},
{"PASS","<SP><password><CRLF>",{230,202,530,500,501,503,421,332}},
{"ACCT","<SP><account-information><CRLF>",{230,202,530,500,501,503,421}},
{"CWD","<SP><pathname><CRLF>",{250,500,501,502,421,530,550}},
{"CDUP","<CRLF>",{200,500,501,502,421,530,550}},
{"SMNT","<SP><pathname><CRLF>",{202,250,500,501,502,421,530,550}},
{"QUIT","<CRLF>",{221,500}},
{"REIN","<CRLF>",{120,220,220,421,500,502}},
{"PORT","<SP><host-port><CRLF>",{200,500,501,421,530}},
{"PASV","<CRLF>",{227,500,501,502,421,530}},
{"TYPE","<SP><type-code><CRLF>",{200,500,501,504,421,530}},
{"STRU","<SP><structure-code><CRLF>",{200,500,501,504,421,530}},
{"MODE","<SP><mode-code><CRLF>",{200,500,501,504,421,530}},
{"RETR","<SP><pathname><CRLF>",{125,150,110,226,250,425,426,451,450,550,500,501,421,530}},
{"STOR","<SP><pathname><CRLF>",{125,150,110,226,250,425,426,451,551,552,532,450,452,553,500,501,421,530}},
{"STOU","<CRLF>",{125,150,110,226,250,425,426,451,551,552,532,450,452,553,500,501,421,530}},
{"APPE","<SP><pathname><CRLF>",{125,150,110,226,250,425,426,451,551,552,532,450,550,452,553,500,501,502,421,530}},
{"ALLO","<SP><decimal-integer>[<SP>R<SP><decimal-integer>]<CRLF>",{200,202,500,501,504,421,530}},
{"REST","<SP><marker><CRLF>",{500,501,502,421,530,350}},
{"RNFR","<SP><pathname><CRLF>",{450,550,500,501,502,421,530,350}},
{"RNTO","<SP><pathname><CRLF>",{250,532,553,500,501,502,503,421,530}},
{"ABOR","<CRLF>",{225,226,500,501,502,421}},
{"DELE","<SP><pathname><CRLF>",{250,450,550,500,501,502,421,530}},
{"RMD","<SP><pathname><CRLF>",{250,500,501,502,421,530,550}},
{"MKD","<SP><pathname><CRLF>",{257,500,501,502,421,530,550}},
{"PWD","<CRLF>",{257,500,501,502,421,550}},
{"LIST","[<SP><pathname>]<CRLF>",{125,150,226,250,425,426,451,450,500,501,502,421,530}},
{"NLST","[<SP><pathname>]<CRLF>",{125,150,226,250,425,426,451,450,500,501,502,421,530}},
{"SITE","<SP><string><CRLF>",{200,202,500,501,530}},
{"SYST","<CRLF>",{215,500,501,502,421}},
{"STAT","[<SP><pathname>]<CRLF>",{211,212,213,450,500,501,502,421,530}},
{"HELP","[<SP><string>]<CRLF>",{211,214,500,501,502,421}},
{"NOOP","<CRLF>",{200,500,421}}
}

include ftpcmds.e
global function parse(sequence in)
        sequence temp
        atom cmd
        temp=upper(in)
        cmd=500
        for i = 1 to length(error_messages) do
                if match(error_messages[i][1],temp)=1 and routine_id("FTP_"&error_messages[i][1])>-1 then
                if not (length(in)>=(length(error_messages[i][1])+1)) then return 500 end if
                in=in[length(error_messages[i][1])+1..length(in)]
                in=in[1..length(in)-2]
                if length(in)>=1 then
                        if in[1] !=32 then
                                in={}
                        else
                                if length(in)>=2 then
                                        in=in[2..length(in)]
                                else
                                        in={}
                                end if
                        end if
                end if
                ? in
                cmd=call_func(routine_id("FTP_"&error_messages[i][1]),{in}) exit end if
        end for
        return cmd
end function
