--Daniel Kluss(xerox_irs@lvcm.com) Registered Euphoria User Since December 2000
include wildcard.e
include misc.e
include base64.e
constant mimes={
        {"application/andrew-inset","ez"},
        {"application/mac-binhex40","hqx"},
        {"application/mac-compactpro","cpt"},
        {"application/msword","doc"},
        {"application/octet-stream","bin","dms","lha","lzh","exe","class"},
        {"application/oda","oda"},
        {"application/pdf","pdf"},
        {"application/postscript","ai","eps","ps"},
        {"application/smil","smi","smil"},
        {"application/vnd.mif","mif"},
        {"application/vnd.ms-excel","xls"},
        {"application/vnd.ms-powerpoint","ppt"},
        {"application/vnd.wap.wbxml","wbxml"},
        {"application/vnd.wap.wmlc","wmlc"},
        {"application/vnd.wap.wmlscriptc","wmlsc"},
        {"application/x-bcpio","bcpio"},
        {"application/x-cdlink","vcd"},
        {"application/x-chess-pgn","pgn"},
        {"application/x-cpio","cpio"},
        {"application/x-csh","csh"},
        {"application/x-director","dcr","dir","dxr"},
        {"application/x-dvi","dvi"},
        {"application/x-futuresplash","spl"},
        {"application/x-gtar","gtar"},
        {"application/x-hdf","hdf"},
        {"application/x-javascript","js"},
        {"application/x-koan","skp","skd","skt","skm"},
        {"application/x-latex","latex"},
        {"application/x-netcdf","nc","cdf"},
        {"application/x-sh","sh"},
        {"application/x-shar","shar"},
        {"application/x-shockwave-flash","swf"},
        {"application/x-stuffit","sit"},
        {"application/x-sv4cpio","sv4cpio"},
        {"application/x-sv4crc","sv4crc"},
        {"application/x-tar","tar"},
        {"application/x-tcl","tcl"},
        {"application/x-tex","tex"},
        {"application/x-texinfo","texinfo","texi"},
        {"application/x-troff","t","tr","roff"},
        {"application/x-troff-man","man"},
        {"application/x-troff-me","me"},
        {"application/x-troff-ms","ms"},
        {"application/x-ustar","ustar"},
        {"application/x-wais-source","src"},
        {"application/zip","zip","exe"},
        {"audio/basic","au","snd"},
        {"audio/midi","mid","midi","kar"},
        {"audio/mpeg","mpga","mp2","mp3"},
        {"audio/x-aiff","aif","aiff","aifc"},
        {"audio/x-pn-realaudio","ram","rm"},
        {"audio/x-pn-realaudio-plugin","rpm"},
        {"audio/x-realaudio","ra"},
        {"audio/x-wav","wav"},
        {"chemical/x-pdb","pdb","xyz"},
        {"image/bmp","bmp"},
        {"image/gif","gif"},
        {"image/ief","ief"},
        {"image/jpeg","jpeg","jpg","jpe"},
        {"image/png","png"},
        {"image/tiff","tiff","tif"},
        {"image/vnd.wap.wbmp","wbmp"},
        {"image/x-cmu-raster","ras"},
        {"image/x-portable-anymap","pnm"},
        {"image/x-portable-bitmap","pbm"},
        {"image/x-portable-graymap","pgm"},
        {"image/x-portable-pixmap","ppm"},
        {"image/x-rgb","rgb"},
        {"image/x-xbitmap","xbm"},
        {"image/x-xpixmap","xpm"},
        {"image/x-xwindowdump","xwd"},
        {"model/iges","igs","iges"},
        {"model/mesh","msh","mesh","silo"},
        {"model/vrml","wrl","vrml"},
        {"text/css","css"},
        {"text/html","html","htm"},
        {"text/plain","asc","txt"},
        {"text/richtext","rtx"},
        {"text/rtf","rtf"},
        {"text/sgml","sgml","sgm"},
        {"text/tab-separated-values","tsv"},
        {"text/vnd.wap.wml","wml"},
        {"text/vnd.wap.wmlscript","wmls"},
        {"text/x-setext","etx"},
        {"text/xml","xml"},
        {"video/mpeg","mpeg","mpg","mpe"},
        {"video/quicktime","qt","mov"},
        {"video/x-msvideo","avi"},
        {"video/x-sgi-movie","movie"},
        {"x-conference/x-cooltalk","ice"}
}

function insert(sequence a,object b,atom s,atom e)
        object beg,en
        if s=1 then beg={}
        elsif s=2 then beg=a[1]
        else beg=a[1..s-1] end if
        if e=length(a) then en={}
        elsif e=(length(a)-1) then en=a[length(a)]
        else en=a[e+1..length(a)] end if
        return beg&b&en
end function

function backward_match(sequence a,sequence b,atom d)
        atom c
        c=0
        for i = d to length(a)+1 by -1 do 
                if equal(a,b[i-length(a)+1..i]) then c=i exit end if
        end for
        return c
end function
function multi_find(sequence a,sequence b)
        sequence ret
        ret={}
        for i = 1 to length(b)-length(a) do
                if equal(a,b[i..i+length(a)-1]) then ret&=i end if
        end for
        return ret
end function

function match2(sequence a,sequence b,atom c)
        for i = c to length(b)-length(a) do
                if equal(a,b[i..i+length(a)-1]) then return i end if
        end for
        return 0
end function

global function get_mime(sequence url)
        atom dot
        url=reverse(url)
        dot=find('.',url)
        if dot then
                url=lower(reverse(url[1..dot-1]))
                for i = 1 to length(mimes) do
                        for ii = 2 to length(mimes[i]) do
                                 if equal(url,mimes[i][ii]) then return mimes[i][1] end if
                        end for
                end for
        else
                return "text/html"
        end if
        return "text/plain"
end function

global function get_form(sequence data)
        object a,b,he
        sequence bound,ret
        a=match("boundary=",data) bound=data[a+9..length(data)]
        a=match("\r\n",bound)  bound=bound[1..a-1]
        a=match("\r\n\r\n",data)
        data=data[a+4..length(data)]
        ret={}
        a=multi_find(45&45&bound,data)
        for i = 1 to length(a)-1 do
                ret&={{{},{},data[a[i]+length(bound)+2..a[i+1]-3]}}
        end for
        for i = 1 to length(ret) do
                he=match("\r\n\r\n",ret[i][3])
                if he then
                a=match("name=\"",ret[i][3])
                b=match2("\"",ret[i][3],a+6)
                if a and b and a<he and b<he then
                        ret[i][1]=ret[i][3][a+6..b-1]
                end if
                a=match("filename=\"",ret[i][3])
                b=match2("\"",ret[i][3],a+10)
                if a and b and a<he and b<he then
                        ret[i][2]=ret[i][3][a+10+backward_match("\\",ret[i][3][a+10..b-1],length(ret[i][3][a+10..b-1]))..b-1]
                end if
                ret[i][3]=ret[i][3][he+4..length(ret[i][3])]
                end if
        end for
        return ret
end function

global function get_form_member(sequence member,sequence form)
        for i = 1 to length(form) do
                if equal(form[i][1],member) then
                        return form[i]
                end if
        end for
        return {member,{},{}}
end function
global function m_decode(sequence encoding,sequence data)
        encoding=lower(encoding)
        if equal(encoding,"base64") then return decode_base64(data)
        elsif equal(encoding,"quoted-printable") then return data
        elsif equal(encoding,"8-bit") then return data
        elsif equal(encoding,"7-bit") then return data
        elsif equal(encoding,"binary") then return data
        elsif equal(encoding,"x-token") then return data
        else return data
        end if
end function

global function m_encode(sequence data)
        atom a
        a=match("\r\n.\r\n",data)
        if a then return {"Content-Transfer-Encoding: base64\r\n",encode_base64(data)} end if
        for i = 1 to length(data) do
                if data[i]>127 then return {"Content-Transfer-Encoding: base64\r\n",encode_base64(data)} end if
        end for
        return {"Content-Transfer-Encoding: quoted-printable",data}
end function

global function mime_decode(sequence data)
        object a,b
        sequence bound,ret,encoding
        a=match("boundary=\"",data)
        if not a then return data end if
        bound=data[a+10..length(data)]
        a=match("\"\r\n",bound)  bound=bound[1..a-1]
        a=match("\r\n\r\n",data)
        data=data[a+4..length(data)]
        ret={}
        a=multi_find(bound,data)
        for i = 1 to length(a)-1 do
                ret&={{{},{},data[a[i]+length(bound)+2..a[i+1]-3]}}
        end for
        for i = 1 to length(ret) do
                if match("boundary",ret[i][3]) then
                        ret[i][3]=mime_decode(ret[i][3])
                else
                a=match("Content-Transfer-Encoding: ", ret[i][3])
                b=match2("\r\n",ret[i][3],a)
                if a and b then encoding=ret[i][3][a+27..b-1] else encoding={} end if
                a=match("name=\"",ret[i][3])
                b=match2("\"",ret[i][3],a+6)
                if a and b then
                        ret[i][1]=ret[i][3][a+6..b-1]
                end if
                a=match("filename=\"",ret[i][3])
                b=match2("\"",ret[i][3],a+10)
                if a and b then
                        ret[i][2]=ret[i][3][a+10..b-1]
                end if
                a=match("\r\n\r\n",ret[i][3])
                if a then ret[i][3]=ret[i][3][a+4..length(ret[i][3])-2] end if
                ret[i][3]=m_decode(encoding,ret[i][3])
                end if
        end for
        return ret
end function

global function mime_encode2(sequence data)
        sequence ret,bound,a
        if atom(data[1]) then a=m_encode(data) return "Content-Type: text/plain\r\n"&a[1]&"\r\n"&a[2] end if
        ret="Content-Type: multipart/mixed;\r\n\t"
        bound="----=_NextPart_"&rand(repeat(25,25))+'a'
        ret&="boundary=\""&bound&"\"\r\n\r\n"
--      ret&="This is a multi-part message in MIME format.\r\n"
        for i = 1 to length(data) do
                ret&="\r\n--"&bound&"\r\n"
                if sequence(data[i][3][1]) then data[i][3]=mime_encode2(data[i][3]) end if
                ret&="Content-Type: "&get_mime(data[i][2])&"\r\n"
                a=m_encode(data[i][3])
                if equal("message",data[i][1]) then ret&=a[1]&"\r\n"&a[2]
                else ret&=a[1]&"\r\nContent-Disposition: attachment;\r\n\tfilename=\""&data[i][2]&"\"\r\n\r\n"&a[2]
                end if
                if i=length(data) then ret&="\r\n--"&bound&"--\r\n" end if
        end for
        return ret
end function

global function mime_encode(sequence data)
return "MIME-Version: 1.0\r\n"&mime_encode2(data)
end function
